/******************************************************************************
 * Copyright (c) 2008 Christian Fonden, Tim Schumacher, Tobias Fink,          *
 *                    Ting Wang, Daniel Hofmann, Vasilios Grigas,             *
 *                    Michael Fechter, Wolfgang Bischoff                      *
 *                                                                            *
 *  This file is part of EvoLab. (Library)                                    *
 *                                                                            *
 *  EvoLab-Library is free software: you can redistribute it and/or modify    *
 *  it under the terms of the MIT/X11 license as published by                 *
 *  the Massachusetts Institute of Technology.                                *
 *                                                                            *
 *  EvoLab is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  MIT/X11 License for more details.                                         *
 *                                                                            *
 *  You should have received a copy of the MIT/X11 License along with EvoLab. *
 *  If not, see <http://www.opensource.org/licenses/mit-license.php>.         *
 ******************************************************************************/

//TODO: Kommentare

namespace EvoLab.Common {

    public interface IConnectionAuthority {

        /// <summary>
        /// Authentifiziert die Verbindung mit den gesetzten Username-
        /// und Password Credentials.
        /// </summary>
        /// <param name="username">Der Name des aufrufenden Benutzers.</param>
        /// <param name="password">Kennwort</param>
        /// <returns>ICore-Object upon successfull authentification,
        /// null otherwise.</returns>
        ICoreConnection Authenticate (string username, string password);
        object Gert ();

    }
}
