/******************************************************************************
 * Copyright (c) 2008 Christian Fonden, Tim Schumacher, Tobias Fink,          *
 *                    Ting Wang, Daniel Hofmann, Vasilios Grigas,             *
 *                    Michael Fechter, Wolfgang Bischoff                      *
 *                                                                            *
 *  This file is part of EvoLab. (Library)                                    *
 *                                                                            *
 *  EvoLab-Library is free software: you can redistribute it and/or modify    *
 *  it under the terms of the MIT/X11 license as published by                 *
 *  the Massachusetts Institute of Technology.                                *
 *                                                                            *
 *  EvoLab is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  MIT/X11 License for more details.                                         *
 *                                                                            *
 *  You should have received a copy of the MIT/X11 License along with EvoLab. *
 *  If not, see <http://www.opensource.org/licenses/mit-license.php>.         *
 ******************************************************************************/

using System;

using EvoLab.CoreApi.Random;

namespace EvoLab.CoreApi.Operators {

    public class Shuffler {

        public static void Shuffle<T> (IRandom rand, T[] deck)
        {
            if (rand == null)
                throw new ArgumentNullException ("rand");
            if (deck == null)
                throw new ArgumentNullException ("deck");

            // TODO (vg) kein gutes Mischen...
            // Die Teilnehmer werden durchmischt:
            int decksize = deck.Length;
            int ran1;
            int ran2;
            T temp;
            for (int i=0; i < (decksize/2); i++)
            {
                ran1 = rand.Next(decksize);
                ran2 = rand.Next(decksize);
                temp = deck[ran1];
                deck[ran1] = deck[ran2];
                deck[ran2] = temp;
            }
        }
    }
}
