/******************************************************************************
 * Copyright (c) 2008 Christian Fonden, Tim Schumacher, Tobias Fink,          *
 *                    Ting Wang, Daniel Hofmann, Vasilios Grigas,             *
 *                    Michael Fechter, Wolfgang Bischoff                      *
 *                                                                            *
 *  This file is part of EvoLab. (Library)                                    *
 *                                                                            *
 *  EvoLab-Library is free software: you can redistribute it and/or modify    *
 *  it under the terms of the MIT/X11 license as published by                 *
 *  the Massachusetts Institute of Technology.                                *
 *                                                                            *
 *  EvoLab is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  MIT/X11 License for more details.                                         *
 *                                                                            *
 *  You should have received a copy of the MIT/X11 License along with EvoLab. *
 *  If not, see <http://www.opensource.org/licenses/mit-license.php>.         *
 ******************************************************************************/

using System;


namespace EvoLab.CoreApi.Parameters {

    /// @cond
    /// <author>Vasilios Grigas</author>
    /// <version>$Revision: 2634 $</version>
    /// <id>$Id: OperatorParameter.cs 2634 2008-04-28 15:28:13Z hofmandl $</id>
    /// @endcond
    /// <summary>
    /// </summary> 
        [System.AttributeUsage(System.AttributeTargets.Class |
            System.AttributeTargets.Struct,
            AllowMultiple = true) ]
    public class OperatorParameter : ParameterAttribute
    {
        public string[] value;
        
        public OperatorParameter (string name, string[] value) : base (name) {
            this.value = value;
        }
        public override object Value {
            get {
                return value;
            }
        }

    }


    /// <summary>
    /// </summary>
    /// @cond
    /// <author>Vasilios Grigas</author>
    /// <version>$Revision: 2634 $</version>
    /// <id>$Id: OperatorParameter.cs 2634 2008-04-28 15:28:13Z hofmandl $</id>
    /// @endcond
        [System.AttributeUsage(System.AttributeTargets.Class |
            System.AttributeTargets.Struct,
            AllowMultiple = true) ]
    public class GlobalOperatorParameter : ParameterAttribute
    {
        public string[] value;
        
        public GlobalOperatorParameter (string name, string[] value) : base (name) {
            this.value = value;
        }
        public override object Value {
            get {
                return value;
            }
        }

    }
}
