/******************************************************************************
 * Copyright (c) 2008 Christian Fonden, Tim Schumacher, Tobias Fink,          *
 *                    Ting Wang, Daniel Hofmann, Vasilios Grigas,             *
 *                    Michael Fechter, Wolfgang Bischoff                      *
 *                                                                            *
 *  This file is part of EvoLab. (Library)                                    *
 *                                                                            *
 *  EvoLab-Library is free software: you can redistribute it and/or modify    *
 *  it under the terms of the MIT/X11 license as published by                 *
 *  the Massachusetts Institute of Technology.                                *
 *                                                                            *
 *  EvoLab is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  MIT/X11 License for more details.                                         *
 *                                                                            *
 *  You should have received a copy of the MIT/X11 License along with EvoLab. *
 *  If not, see <http://www.opensource.org/licenses/mit-license.php>.         *
 ******************************************************************************/

using System;

namespace EvoLab.CoreApi.Random {

    /// <summary>
    /// Diese Klasse dient dazu, die System.Random-Klasse in das
    /// IRandom-Interface einzupassen.
    /// </summary> 
    public class RandomWrapper : AbstractRandom {

        private readonly System.Random rand;

        public RandomWrapper () {
            rand = new System.Random ();
        }

        public RandomWrapper (int seed) {
            rand = new System.Random (seed);
        }

        public override int Next() {
            return rand.Next ();
        }

        public override int Next( int maxValue ) {
            return rand.Next (maxValue);
        }

        public override int Next( int minValue, int maxValue ) {
            return rand.Next (minValue, maxValue);
        }

        public override double NextDouble() {
            return rand.NextDouble ();
        }
    }
}
