/******************************************************************************
 * Copyright (c) 2008 Christian Fonden, Tim Schumacher, Tobias Fink,          *
 *                    Ting Wang, Daniel Hofmann, Vasilios Grigas,             *
 *                    Michael Fechter, Wolfgang Bischoff                      *
 *                                                                            *
 *  This file is part of EvoLab. (Library)                                    *
 *                                                                            *
 *  EvoLab-Library is free software: you can redistribute it and/or modify    *
 *  it under the terms of the MIT/X11 license as published by                 *
 *  the Massachusetts Institute of Technology.                                *
 *                                                                            *
 *  EvoLab is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  MIT/X11 License for more details.                                         *
 *                                                                            *
 *  You should have received a copy of the MIT/X11 License along with EvoLab. *
 *  If not, see <http://www.opensource.org/licenses/mit-license.php>.         *
 ******************************************************************************/

using System;

namespace EvoLab.CoreApi
{
    /// <summary>
    /// Enth�lt alle m�glichen Ereignis-Arten, die zwischen Simulationen 
    /// kommuniziert werden k�nnen.
    /// </summary>
    /// @cond
    /// <author>Tim Schuhmacher</author>
    /// <version>$Revision: 2634 $</version>
    /// <id>$Id: SimEventType.cs 2634 2008-04-28 15:28:13Z hofmandl $</id>
    /// @endcond
    [Serializable]
    public enum SimEventType
    {
        ERROR,
        PAUSED,
        STOPPED,
        FINISHED,
        STARTED,
        DELETED,
        RESTORED,
        CONTINUED,
        EXIT
    }
}
