using EvoLab.CoreApi;
using EvoLab.CoreApi.ModuleTemplates;
using EvoLab.CoreApi.Parameters;

using EvoLab.CoreApi.Populations;
using EvoLab.CoreApi.Individuals;

namespace FitnessFunctions {
    
    [Author("Lieferumfang von EvoLab")]
    [Description("Berechnet die Fitness für jedes Individuum")]
    [Identifier("Fitness_Djong")]
    public sealed class Fitness_Djong<I, P>
    : Fitness<I, P> where I : DoubleVector where P : IPopulation<I>
    {
        public override void Evaluate (I ind)
        {
            double sum = 0.0f;
            for (int i = 0; i < ind.vector.Length; ++i) {
                sum += DjongSummand (ind.vector[i], i+1);
            }
            ind.Fitness = sum;
        }

        private double DjongSummand (double xi, int i)
        {
            return i * System.Math.Pow (xi, 2);
        }
    }
}
